<?php

class parsePush extends parseRestClient{

	public $channels;
	public $channel;
	public $expiration_time;
	public $expiration_time_intreval;
	public $content_available;
	public $type;
	public $title;
	public $where;
	public $appid;
	public $masterkey;
	public $restkey;
	public $parseurl;

	private $_globalMsg;

	public function __construct($appid, $masterkey, $restkey, $parseurl, $globalMsg = ''){
		if ($globalMsg != '') {
			$this->_globalMsg = $globalMsg;
		}
		parent::__construct($appid, $masterkey, $restkey, $parseurl);
	}
	
	public function __set($name,$value){
		if($name != 'channel' || $name != 'channels' || $name != 'expiration_time' || $name != 'expiration_interval' || $name != 'type' || $name != 'data' || $name != 'where'){
			$this->data[$name] = $value;
		}
	}

	public function send(){
		if (!empty($this->_globalMsg)){
			$request = $this->request(array(
				'method' => 'POST',
				'requestUrl' => 'push',
				'data' => array(
					'channel' => '',
					'data' => array(
						'alert' => $this->_globalMsg,
						'sound' => 'default',
					)
				),
			));
			return $request;

		}
		else{
			if(count($this->data) > 0){
				if($this->channel == '' && empty($this->channels) && empty($this->where)){
					$this->throwError('A push Channel must be set when not using Advanced Targeting');
				}
				$params = array(
					'method' => 'POST',
					'requestUrl' => 'push',
					'data' => array(
						'data' => $this->data,
					)
				);
				
				if(!empty($this->channels)){
					$params['data']['channels'] = $this->channels;
				}
				if(!empty($this->channel)){
					$params['data']['channel'] = $this->channel;
				}
				if(!empty($this->expiration_time)){
					$params['data']['expiration_time'] = $this->expiration_time;
				}
				if(!empty($this->expiration_time_interval)){
					$params['data']['expiration_interval'] = $this->expiration_interval;
				}
				if(!empty($this->content_available)){
					//changed back to content-available... underscores are much easier to deal with in PHP
					$params['data']['content-available'] = $this->content_available;
				}
				if(!empty($this->type)){
					$params['data']['type'] = $this->type;
				}
				if(!empty($this->where)){
					$params['data']['where'] = $this->where;
				}
				
				$request = $this->request($params);
				return $request;

			}
			else{
				$this->throwError('No push data has been set, you must set at least data. Please see the docs. ');
			}
		}
	}
}

?>